package ovh.toms.flyfeather.listener;

import org.bukkit.Bukkit;
import org.bukkit.Material;
import org.bukkit.Sound;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.block.Action;
import org.bukkit.event.player.PlayerInteractEvent;
import org.bukkit.util.Vector;
import ovh.toms.flyfeather.FlyFeather;
import ovh.toms.flyfeather.misc.Variables;

/**
 * Created by Tom S. on 15.12.17
 * This code is property of Tysox.de Development
 * (c) 2015-2017
 */
public class PlayerInteractListener implements Listener {

    @EventHandler
    public void onFeatherInteract(PlayerInteractEvent event) {
        Player player = event.getPlayer();
        if (event.getAction() == Action.RIGHT_CLICK_AIR || event.getAction() == Action.RIGHT_CLICK_BLOCK) {
            if (event.getItem().getType() == Material.FEATHER && event.getItem().getItemMeta().getDisplayName().equals("§6Fliegen §aaktiviert")) {
                if (player.hasPermission(FlyFeather.getInstance().getConfigManager().getSettings().getConfiguration().getString("Permission"))) {
                    player.setAllowFlight(false);
                    player.setFlying(false);
                    player.getInventory().setItem(
                            FlyFeather.getInstance().getConfigManager().getSettings().getConfiguration().getInt("slot") -1,
                            Variables.getDisabledFeather());
                    player.playSound(player.getLocation(), Sound.FIREWORK_BLAST2, 1, 1);
                    FlyFeather.getInstance().getEnabledFly().remove(player);
                    player.sendMessage("§cDu darfst nun nicht mehr fliegen.");
                }
            } else if (event.getItem().getType() == Material.FEATHER && event.getItem().getItemMeta().getDisplayName().equals("§6Fliegen §cdeaktiviert")) {
                if (player.hasPermission(FlyFeather.getInstance().getConfigManager().getSettings().getConfiguration().getString("Permission"))) {
                    Bukkit.getScheduler().runTaskLaterAsynchronously(FlyFeather.getInstance(), () -> player.setVelocity(new Vector(0, 2, 0)), 5);
                    player.setAllowFlight(true);
                    Bukkit.getScheduler().runTaskLater(FlyFeather.getInstance(), () -> player.setFlying(true), 20);
                    player.getInventory().setItem(
                            FlyFeather.getInstance().getConfigManager().getSettings().getConfiguration().getInt("slot") -1,
                            Variables.getEnabledFeather());
                    player.playSound(player.getLocation(), Sound.FIREWORK_BLAST, 1, 1);
                    FlyFeather.getInstance().getEnabledFly().add(player);
                    player.sendMessage("§aDu darfst nun fliegen.");
                }
            }
        }
    }

}
