package ovh.toms.flyfeather.api;

import org.bukkit.entity.Player;
import org.bukkit.inventory.ItemStack;
import ovh.toms.flyfeather.FlyFeather;
import ovh.toms.flyfeather.misc.Variables;

/**
 * Created by Tom S. on 15.12.17
 * This code is property of Tysox.de Development
 * (c) 2015-2017
 */
public class FlyFeatherAPI {

    public static ItemStack getEnabledFeatherItemStack() {
        return Variables.getEnabledFeather();
    }

    public static ItemStack getDisabledFeatherItemStack() {
        return Variables.getDisabledFeather();
    }

    public static void setPlayerItem(Player player) {
        if (FlyFeather.getInstance().getEnabledFly().contains(player))
            player.getInventory().setItem(
                    FlyFeather.getInstance().getConfigManager().getSettings().getConfiguration().getInt("slot") - 1,
                    Variables.getEnabledFeather());
        else
            player.getInventory().setItem(
                    FlyFeather.getInstance().getConfigManager().getSettings().getConfiguration().getInt("slot") - 1,
                    Variables.getDisabledFeather());
    }
}
