package ovh.toms.flyfeather.misc;

import org.bukkit.Material;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;

/**
 * Created by Tom S. on 15.12.17
 * This code is property of Tysox.de Development
 * (c) 2015-2017
 */
public class Variables {

    private static ItemStack itemStackDisabled = new ItemStack(Material.FEATHER, 1);
    private static ItemMeta itemMetaDisabled = itemStackDisabled.getItemMeta();

    private static ItemStack itemStackEnabled = new ItemStack(Material.FEATHER, 1);
    private static ItemMeta itemMetaEnabled = itemStackEnabled.getItemMeta();

    public static void initialize() {
        itemMetaDisabled.setDisplayName("§6Fliegen §cdeaktiviert");
        itemStackDisabled.setItemMeta(itemMetaDisabled);
        itemMetaEnabled.setDisplayName("§6Fliegen §aaktiviert");
        itemStackEnabled.setItemMeta(itemMetaEnabled);
    }

    public static ItemStack getEnabledFeather() {
        return itemStackEnabled;
    }

    public static ItemStack getDisabledFeather() {
        return itemStackDisabled;
    }
}
